/*---------------------------------------------------------------------------*\
 *           interactive networked Virtual Reality system (inVRs)            *
 *                                                                           *
 *    Copyright (C) 2005-2009 by the Johannes Kepler University, Linz        *
 *                                                                           *
 *                            www.inVRs.org                                  *
 *                                                                           *
 *              contact: canthes@inVRs.org, rlander@inVRs.org                *
\*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
\*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

#ifndef _TIMER_H_
#define _TIMER_H_

#include "Platform.h"

namespace inVRsUtilities {

class INVRS_SYSTEMCORE_API Timer {
public:

	//*****************//
	// PUBLIC METHODS: //
	//*****************//

	/** Constructor
	 */
	Timer(bool start = false);

	/** Desctructor
	 */
	~Timer();

	/**
	 */
	void start();

	/**
	 */
	void stop();

	/**
	 */
	void reset();

	/**
	 */
	void setSpeed(double speed);

	/**
	 */
	double getSystemTime();

	/**
	 */
	double getTime();

	/**
	 */
	double getTimeInMilliseconds();

	/**
	 */
	double getSpeed();

	/**
	 */
	bool isRunning();

protected:

	//********************//
	// PROTECTED METHODS: //
	//********************//

	//	void initialize

	//********************//
	// PROTECTED MEMBERS: //
	//********************//

	/// Time the timer was started
	double startTime;

	/// Value of the timer, always updated when getTime is called
	double timerValue;

	/// Value of the system time at last request
	double previousTime;

	/// factor of timer speed
	double speedFactor;

	/// defines if the timer is running
	bool running;

}; // Timer

} // inVRsUtilities

extern INVRS_SYSTEMCORE_API inVRsUtilities::Timer timer;

#endif /*_TIMER_H_*/
