
#ifndef VRPN_TRACKEREMULATIONMOUSE_H
#define VRPN_TRACKEREMULATIONMOUSE_H
#include "vrpn_Analog.h"
#include "vrpn_Button.h"
#include "vrpn_Tracker.h"

#include <string>

struct TrackerData {
	vrpn_Tracker_Pos position;
	vrpn_Tracker_Quat orientation;
};

/**
  * class vrpn_TrackerEmulationMouse
  * 
  */

class VRPN_API vrpn_TrackerEmulationMouse : public vrpn_Analog, public vrpn_Button_Filter, public vrpn_Tracker
{
public:

	// Constructors/Destructors
	//  


	/**
	 * @param  name
	 * @param  c
	 */
	vrpn_TrackerEmulationMouse (const char * name, vrpn_Connection * c );

	/**
	 * Empty Destructor
	 */
	virtual ~vrpn_TrackerEmulationMouse();

	// Static Public attributes
	//  

	// Public attributes
	//  


	// Public attribute accessor methods
	//  


	// Public attribute accessor methods
	//  


	/**
	 * @return void
	 */
	virtual void mainloop();

protected:

	// Static Protected attributes
	//  

	// Protected attributes
	//  
	bool isActive;
	bool switchActivation;
	bool emulationActive;
	bool switchEmulation;
	int trackerIndex;
	bool switchTracker;
	int selectedAxes;
	bool switchAxes;
	int transformationTarget;
	bool switchTransformationTarget;

	TrackerData trackerValues[2];

	timeval *lastTime;

protected:



	/**
	 * @param  dt
	 */
	void updateButtons(double dt);


	/**
	 * @param  dt
	 */
	void updateAnalog(double dt);


	/**
	 * @param  dt
	 * @param  currentTime
	 */
	void updateTracker(double dt);

	
	/**
	 * @param currentTime
	 */
	void reportChanges(timeval currentTime);
	

	/**
	 *
	 */
	void checkActivationSwitch();


	/**
	 *
	 */
	void checkEmulationSwitch();


	/**
	 *
	 */
	void checkTrackerSwitch();


	/**
	 *
	 */
	void checkAxesSwitch();


	/**
	 *
	 */
	void checkTransformationTargetSwitch();


	/**
	 *
	 */
	void warpMouse();

	/**
	 *
	 */
	int getMouseButton(int index);


	/**
	 *
	 */
	vrpn_float64 getMousePosition(int index);


	/**
	 *
	 */
	bool getKeyboardState(unsigned char state[256]);
};

#endif // VRPN_TRACKEREMULATIONMOUSE_H
